# Debugging with Visual Studio
## Objectives

In this lesson, we are going to quickly go over how to debug with Visual Studio. This lesson assumes that you have a basic understanding of debugging terms. 
**Topics include:**
* **Running the Program**
* **Error List**
* **Breakpoints**
* **Running in Debugging Mode**
* **Stepping through the Program**
* **Adding to Watch**
* **Evaluating Expressions**
* **Additional Tools**
* **Peaking/Go to definitions**
* **Additional Windows**
* **Diagnostic Tools Window**

**Note:** This lesson assumes that the student is familiar with basic debugging terms

---
## The "Program" we are going to debug:

Paste the following code into your visual studio, code window.  Save the code and then try and run it.

`main.c`

```c
#include <stdio.h>
#include <string.h>
#include <math.h>

int square(int a);


int main() {
    printf("Hello, World!\n");

    int a = 10;
    char x[] = {"This is a string"};
    int sqNum = 0;

    for (int i = 0; i < a; i++) {
        printf("%d\n", i);
    }

    for (int i = 0; i <= strlen(x); i++) {
        printf("%c", x[i]);
    }
    printf("\n");

    printf("===========\n");
    printf("Enter a number that you'd like to find the sqrt of:");
    scanf("%d", sqNum);
    printf("The square root of %d is %d\n", sqNum, square(sqNum));

    return 0;
}


int square(int a) {
    return sqrt(a);
}
```

We do not have any other files. A CMake file isn't needed, since Visual Studio keeps track of built properties for you. 

---
### Running the Program

Visual Studio will not allow us to run this program. When we attempt to run it, we receive a message:

![](../assets/vs_error.PNG)

If we click yes, the project will attempt to build. The executable will be produced, but will not run. 
If we click no, we will be given the errors immediately. Let's click no. 

---
## Error List

The first error. An error will have a red X graphic next to it.  A warning will have a yellow ! graphic.

![](../assets/vs_error_list.PNG)

The warning says;

`'scanf': This function or variable may be unsafe. Consider using scanf_s instead. To disable deprecation, use _CRT_SECURE_NO_WARNINGS.`

---
## Warning Breakout

The warning breakout is as follows:

* **'scanf': This function or variable may be unsafe. Consider using scanf_s instead.** 
* **To disable deprecation, use _CRT_SECURE_NO_WARNINGS.**

The Visual Studio build tool requires some C functionality to have _CRT_SECURE_NO_WARNINGS defined. 

Add,

`#define _CRT_SECURE_NO_WARNINGS 1` to the top of our file (all the way at the top). There is a way to do this that will also work at the pre-processor level. Feel free to look it up on your own or wait until we cover the preprocessor. 

Once you have done that, run the program again. A console window should pop up. 

![](../assets/vs_output1.PNG)

Okay, now our program is building and the executable is runnable. 

---
## Breakpoints

Visual Studio allows you to create breakpoints.  Accomplish this by clicking next to the number on the code screen that you want to stop running the code.
put a breakpoint on `line 15`

![](../assets/vs_breakpoint.PNG)

---
## Running in Debugging Mode

Engage debugging mode by first ensuring the build type is debug, and then click the build+run button. Refer to 04.0 for how the toolbar should look. 

Some windows will pop up.

---
### Auto/Locals

These windows show variable values while you are debugging. The windows are only shown when in a debugging session. 
*  The Autos window shows variables used around the current breakpoint.
*  The Locals window shows variables defined in the local scope, which is usually the current function or method.
  
![](../assets/vs_debug_win1.PNG)

---
### Error List

This window is pretty awesome. It will show all warning and errors that it finds. Regardless if the program executed or not. As you can see, we have 3 warnings. 

![](../assets/vs_debug_win2.PNG)


---
### Expanding Arrays

By left clicking on the arrow next to the symbol, you can expand the array.

![](../assets/vs_string.PNG)

## Stepping Through the Program

The toolbar to perform this is near the build+run toolbar.  You can also use shortcuts or the dropdown menu. 

![](../assets/vs_step.PNG)

Try stepping through the program. 

---
## Adding to Watch

Watch windows can display several variables at a time while debugging. Just right click and add to watch.

![](../assets/vs_watch.PNG)

Take a look at the bottom of the screenshot above. Notice the three tabs? 

* `Locals` window shows variables defined in the local scope
* `Autos` window shows variables used around the current breakpoint
* `Watch 1` You may open a Watch window by selecting Debug > Windows > Watch > Watch 1

---
## Quick Watch (Evaluating Expressions)

To access quick watch; click `Quick Watch`. 

![](../assets/vs_quick_watch.PNG)

You can add it to watch once you have entered a name.  You may also right click the expression and add it straight to the watch.

---
## Changing Values

Changing Values is fairly easy in Visual Studio. Make sure to pay attention to the autos/local/watch window. Double click the variables current value allows you to change that value. 

---
## Peaking/Go to Definitions

Let's assume we are working on a huge C Project. You imported a header full of functions that we are going to utilize in this current file. But you have no idea what they do. Luckily for you, Visual Studio allows us to peak the definition of said function... or even go to it if we please. 

To do so, right click said function and click `Peak Definition`

![](../assets/vs_peak.PNG)

---
## Function Purposes
On the right side of the file where the definition is located, is `main.c`. We can do a variety of things by right clicking a function.

![](../assets/vs_right_click.PNG)

* Go To Definition: Goes to the definitions file and location
* Go to Declaration: Goes to the declarations file and location
* Find All References: Displays all references to said function
* Rename: Refactors the name of the function across all files
* Go to Disassembly: Goes to disassembly of a function line, etc.
  * We will be using this often in the Windows ASM section
  * There are multiple windows associated with this. Many will be listed below.

---
## Additional Windows

![](../assets/vs_debug_windows.PNG)

* Breakpoints
  * This window will display all breakpoints and their locations
* Call Stack
  * This window will display the call stack in its current layout
* Registers
  * This window will display the ASM registers and their current values
* Memory
  * This dropdown will give you the different setups of memory. You can configure their data size output and view whats currently in memory. 

---
## Diagnostic Tools Window
![](../assets/vs_stats.PNG)

The diagnostic tools window is located on the right side of the console window.  It shows a snapshot of the resources that your program is using. It's useful for detecting memory leaks and performance of your program

---
## Summary

Again, this is not everything you can do in Visual Studio. There are so many tools you can explorer. Feel free to do so!

**Topics covered:**
* **Running the Program**
* **Error List**
* **Breakpoints**
* **Running in Debugging Mode**
* **Stepping through the Program**
* **Adding to Watch**
* **Evaluating Expressions**
* **Additional Tools**
* **Peaking/Go to definitions**
* **Additional Windows**
* **Diagnostic Tools Window**
